# $Id: vsl2c.sed,v 1.6 1997/10/03 10:42:03 zeller Exp $
#
# vsl2c: Convert VSL file to C strings declarations.

# Copyright (C) 1995 Technische Universitaet Braunschweig, Germany.
# Written by Andreas Zeller <zeller@ips.cs.tu-bs.de>.
# 
# This file is part of the DDD Library.
# 
# The DDD Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# The DDD Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Library General Public License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with the DDD Library -- see the file COPYING.LIB.
# If not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
# DDD is the data display debugger.
# For details, see the DDD World-Wide-Web page, 
# `http://www.cs.tu-bs.de/softech/ddd/',
# or send a mail to the DDD developers <ddd@ips.cs.tu-bs.de>.

# Strip C++ comments
s,//[^"]*$,,
s,[^"]*//.*$,,

# Add real line info
s/^# *\([1-9][0-9]*\)[^"]*\("[^"]*\)tmp.c".*/#line \1 \2ddd.vsl"/
s/^# *\([1-9][0-9]*\)[^"]*\("[^"]*"\).*/#line \1 \2/
s/^# *\([1-9][0-9]*\)[^"]*$/#line \1/

# Remove leading and trailing whitespace
s/^\([^" 	]*\)[ 	]*/\1 /g
s/^[ 	]*//
s/[ 	]*$//

# Delete empty lines
# /^[ 	]*$/d

# Quote strings
s/\\/\\&/g
s/"/\\"/g

# Add newlines
s/$/&\\n/

# Enclose in double quotes
s/.*/"&"/
